#include <iostream>
#include "lib/menu/menu_common.h"

void on_menu_select_1(action_t* action){
    std::cout << "Selected option 1!" << std::endl;
}

void on_menu_select_2(action_t* action){
    std::cout << "Selected option 2!" << std::endl;
}

void funny_text(action_t* action){
    std::cout << "***** ***";
}



menu_t* menu2  = (new menu_t())
        ->add_option(MENU_SIMPLE_OPTION("1. Tell me a joke \n", funny_text, action_type_t::ON_PRESS))
        ->add_option(MENU_BACK_OPTION("2. Back \n");

menu_t* menu1 = (new menu_t())
        ->add_option(MENU_SIMPLE_OPTION("1. Select option 2 \n", on_menu_select_2, action_type_t::ON_PRESS))
        ->add_option(MENU_SUBMENU_OPTION("2. More... \n", new submenu_action_t(menu2)))
        ->add_option(MENU_BACK_OPTION("3. Back \n");

menu_t* menu = (new menu_t())
        ->add_option(MENU_SIMPLE_OPTION("1. Select option 1 \n", on_menu_select_1, action_type_t::ON_PRESS))
        ->add_option(MENU_SUBMENU_OPTION("2. More... \n",
                                         new submenu_action_t(menu1)));


int main() {
    menu_common_t::open_menu(menu);

    return 0;
}
